#ifndef _VERTEX_H_
#define _VERTEX_H_
 
#include <vector>
#include <algorithm>
#include <cstdio>
#include "vector3d.h"

class Edge;
class Face;

class Vertex : public Vector3d {
public:
  Vertex();
  Vertex(const double&,const double&,const double&);
  Vertex(const Vertex&);
  Vertex(const Vector3d&);
  ~Vertex();
  
  //   vertex only
  const Vertex& operator=(const Vertex&);

  void SetV(Vertex&);
  Vertex CalcVertexPoint();
  void ConnectToEdgePoint();
  void SetEdgeLink();
  void SetFaceLink();
  void UnSetFaceLink(int);
  void UnSetEdgeLink(int);

  void Sharp();
  void Smooth();
  void MoreSharp();
  void MoreSmooth();
  void SetWeight(float);
  float ReturnWeight();

  void Draw();
  void Info();
  void WriteFile(FILE*);
  void ReadFile(FILE*);
  int HaveEdge(int);
  int haveCrossEdge();
  
  vector<int> edgePLink; // int number specify edge number
  vector<int> facePLink; // int number specify face number

  int vertexPointLink; // order of calculated Vertex Point 

  float weight; // big weight pull vertex point
private:
protected:
};

#endif // _VERTEX_H

